Package org.zkoss.stateless.sul

## Interface ICascader

- All Superinterfaces:
    `IAnyGroup<ICascader>`, `IComponent<ICascader>`, `IDisable<ICascader>`, `IHtmlBasedComponent<ICascader>`

      public interface ICascader
      extends IHtmlBasedComponent<ICascader>, IDisable<ICascader>, IAnyGroup<ICascader>

  Immutable `Cascader` component

  A Cascader is a dropdown list in tree structure, and it supports TreeModel. It does not create child widgets for each data, so the memory usage is much lower at the server.

  ### Support @Action

  Name | Action Type
  --- | ---
  onSelect | ActionData: `SelectData` Represents an action caused by user's the list selection is changed at the client.
  onOpen | ActionData: `OpenData` Represents an event that indicates an open state that is changed at the client.

  Author:
    katherine
  See Also:
    `Cascader`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `ICascader.Builder` | Builds instances of type `ICascader`.
    `static class` | `ICascader.Updater` | Builds an updater of type `ICascader` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ICascader` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getPlaceholder()` | Returns the placeholder text.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default boolean` | `isOpen()` | Returns whether this cascader is open.
    `static ICascader` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `ICascader` | `withOpen​(boolean open)` | Returns a copy of `this` immutable component with the specified `open`.
    `ICascader` | `withPlaceholder​(java.lang.String placeholder)` | Returns a copy of `this` immutable component with the specified `placeholder`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IDisable

      `isDisabled, withDisabled`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

- - ### Field Detail

    - #### DEFAULT

          static final ICascader DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zkmax.inp.Cascader"`

      Specified by:
        `getWidgetClass` in interface `IComponent<ICascader>`
      Returns:

    - #### getPlaceholder

          @Nullable
          java.lang.String getPlaceholder()

      Returns the placeholder text.

      Default: `null`

    - #### withPlaceholder

          ICascader withPlaceholder​(@Nullable
                                    java.lang.String placeholder)

      Returns a copy of `this` immutable component with the specified `placeholder`.

      Sets the placeholder text that is displayed when the selected item is empty.

      Parameters:
        `placeholder` - The placeholder text.

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### isOpen

          default boolean isOpen()

      Returns whether this cascader is open.

      Default: `false`.

    - #### withOpen

          ICascader withOpen​(boolean open)

      Returns a copy of `this` immutable component with the specified `open`.

      Sets whether to open the dropdown or closes the list of items.

      Parameters:
        `open` - Whether to open the dropdown or closes the list of items.

        Default: `false`.

      Returns:
        A modified copy of the `this` object

    - #### ofId

          static ICascader ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component